/*      Horner-Algorithmus                                      */
/*      Burkhard Lenze                                          */
/*      30.06.2000                                              */

#include <stdio.h>
#include <math.h>

typedef double feld[11];
void moncoef(void);
double horner(double,int,feld);
feld a;
int n;

void moncoef(void) 
{
/* Verzicht auf Einleseroutine und direkter Zugriff auf Aufgabendaten des Skripts */
        n=5;
        a[0]=8.0;
        a[1]=-4.0;
        a[2]=0.0;
        a[3]=2.0;
        a[4]=-4.0;
        a[5]=2.0;
}

double horner(double x0, int n, feld a)
{
        int k;
        feld b;
        b[n]=a[n];
        for(k=1;k<=n;k++) b[n-k]=b[n-k+1]*x0+a[n-k];
        return (b[0]);
}

/* Hauptprogramm */
int main(void)
{
        int k;
        double x0=-1.0,px0;
        moncoef();
        px0=horner(x0,n,a);
        printf("\n");
        printf("\n");
        printf("Auszuwerten ist ein Polynom p vom Grad %i.\n",n);
        printf("\n");
        printf("\n");
        for(k=0;k<=n;k++)
                printf("Der %i-te Monom-Koeffizient des Polynoms p lautet % .12E.\n",k,a[k]);
        printf("\n");
        printf("\n");
        printf("Der Auswertungspunkt ist gegeben als x0 = %.12E.\n",x0);
        printf("\n");
        printf("Der Horner-Algorithmus liefert p(x0) = %.12E.\n",px0);
        return(0);
}
