/*      Nullstellenberechnung                                   */
/*      Burkhard Lenze                                          */
/*      30.06.2000                                              */

#include <stdio.h>
#include <math.h>
long double funk(long double);
long double funkstr(long double);
void sekanten(int,long double,long double);
void newton(int,long double);

long double funk(long double x)
{
        return (x-exp(-x*x));
}

long double funkstr(long double x)
{
        return (1.0+2.0*x*exp(-x*x));
}

void sekanten(int n, long double x0, long double x1)
{
        int i;
        long double x,xx,xxx;
        x=x0;
        xx=x1;
        for(i=1;i<=n;i++)
        {
                printf("Die %.2i-te Sekanten-Naeherung lautet: % .12LE.\n",i,xx);
                xxx=x;
                x=xx;
                xx=xxx-(funk(xxx)*(xx-xxx)/(funk(xx)-funk(xxx)));
        }
}

void newton(int n, long double x0)
{
        int i;
        long double x;
        x=x0;
        for(i=0;i<=n;i++)
        {
                printf("Die %.2i-te Newton-Naeherung lautet: % .12LE.\n",i,x);
                x=x-(funk(x)/funkstr(x));
        }
}

/* Hauptprogramm */
int main(void)
{
        long double x0=0.0,x1=2.0;
        sekanten(10,x0,x1);
        printf("\n");
        printf("\n");
        printf("\n");
        newton(10,x0);
        printf("\n");
        return(0);
}
